import structs.FrameData;
import structs.GameData;
import structs.Key;
import gameInterface.AIInterface;
import commandcenter.CommandCenter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Random;
import java.util.Map;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;


public class ASH implements AIInterface {

	Key inputKey;
	boolean playerNumber;
	FrameData frameData;
	CommandCenter cc;
	
	class condition{
		public String dist,energy;
		
		public int rateTotal;
		
		public Map<String,Integer> actionRate;
		
		public condition(String dist,String energy){
			this.dist = dist;
			this.energy = energy;
			this.rateTotal=0;
			this.actionRate = new HashMap<String,Integer>();
		}
		
		public condition(){
			this.rateTotal=0;
			this.actionRate = new HashMap<String,Integer>(); 
		}
	}
	
	public class chAction{
		public int near=50,close=100,far=540;
		int low=50,high=300;
		
		ArrayList<condition> conditions;
		Map<String, ArrayList<condition> >StateChoice;
		Map<String, ArrayList<condition> >StartWith;
		
		public String getDistance(){
			if(cc.getDistanceX()<=near){
				return "near";
			}
			else if(cc.getDistanceX()>near && cc.getDistanceX()<=close){
				return "close";
			}
			else if(cc.getDistanceX()<=far && cc.getDistanceX()>close){
				return "mid";
			}
			else{
				return "far";
			}
		}
		public int getIntDistance(){
			if(cc.getDistanceX()<=near){
				return 3;
			}
			else if(cc.getDistanceX()>near && cc.getDistanceX()<=close){
				return 2;
			}
			else if(cc.getDistanceX()<=far && cc.getDistanceX()>close){
				return 1;
			}
			else{
				return 0;
			}
		}
		
		public String getEnergyLevel(){
			if(cc.getMyEnergy()<=low){
				return "low";
			}
			else if(cc.getMyEnergy()<=high && cc.getMyEnergy()>low){
				return "mid";
			}
			else{
				return "high";
			}
		}
		public int getIntEnergyLevel(){
			if(cc.getMyEnergy()<=low){
				return 2;
			}
			else if(cc.getMyEnergy()<=high && cc.getMyEnergy()>low){
				return 1;
			}
			else{
				return 0;
			}
		}
		
		public chAction(int near,int close,int far){
			this.near = near;
			this.close = close;
			this.far = far;
			this.conditions = new ArrayList<condition>();
			this.StartWith = new HashMap<String, ArrayList<condition> >();
			this.StateChoice = new HashMap<String, ArrayList<condition> >();
			
			for(int i=0;i<12;++i){
				String dist,energy;
				if(i/3 == 0){
					dist = "far";
				}
				else if(i/3 == 1){
					dist = "mid";
				}
				else if(i/3 == 2){
					dist = "close";
				}
				else{
					dist = "near";
				}
				
				if(i%3==0){
					energy = "high";
				}
				else if(i%3==1){
					energy = "mid";
				}
				else{
					energy = "low";
				}
				this.conditions.add(new condition(dist,energy));
			}
		}
		public chAction(){
			this.conditions = new ArrayList<condition>();
			this.StartWith = new HashMap<String, ArrayList<condition> >();
			this.StateChoice = new HashMap<String, ArrayList<condition> >();
			
			for(int i=0;i<12;++i){
				String dist,energy;
				if(i/3 == 0){
					dist = "far";
				}
				else if(i/3 == 1){
					dist = "mid";
				}
				else if(i/3 == 2){
					dist = "close";
				}
				else{
					dist = "near";
				}
				
				if(i%3==0){
					energy = "high";
				}
				else if(i%3==1){
					energy = "mid";
				}
				else{
					energy = "low";
				}
				this.conditions.add(new condition(dist,energy));
			}
		}
	}
	
	ArrayList<chAction> characters = null;
	final int dataNum = 2;
	BufferedReader br = null;
	Random rnd;
	
	@Override
	public int initialize(GameData gd, boolean pn) {
		// TODO Auto-generated method stub
		this.playerNumber = pn;
		this.inputKey = new Key();
		cc = new CommandCenter();
		frameData = new FrameData();
		rnd=new Random();
		this.characters = new ArrayList<chAction>();
		
		try {
			for(int i=0;i<dataNum;++i){
				br = new BufferedReader(new FileReader("data/aiData/ASH/ASH"+i+".txt"));
				String line="";
				line = br.readLine();
				chAction tempCA = new chAction();
				
				
				while(line != null)
				{
					String[] lines=line.split(" ");
					if(!lines[0].equals("nil")){
						if(lines[0].startsWith("StartWith:")){
							ArrayList<condition> temp=tempCA.StartWith.get(lines[0].substring(10));
							if(temp==null){
								temp = new ArrayList<condition>(); 
							}
							
							int conInd=-1;
							for(int j=0;j<temp.size();++j){
								if(lines[1].equals(temp.get(j).dist) && lines[2].equals(temp.get(j).energy)){
									conInd = j;
									break;
								}
							}
							if(conInd==-1){
								condition cnd = new condition(lines[1],lines[2]);
								cnd.actionRate.put(lines[3], Integer.valueOf(lines[4]));
								conInd = temp.size();
								temp.add(cnd);
							}
							else{
								temp.get(conInd).actionRate.put(lines[3], Integer.valueOf(lines[4]));;
							}
							tempCA.StartWith.put(lines[0].substring(10), temp);
						}
						else if(lines[0].startsWith("State:")){
							if(tempCA.StateChoice.get(lines[0])==null){
								tempCA.StateChoice.put(lines[0],new ArrayList<condition>()); 
							}
							
							int conInd=-1;
							for(int j=0;j<tempCA.StateChoice.get(lines[0]).size();++j){
								if( lines[1].equals(tempCA.StateChoice.get(lines[0]).get(j).dist) 
									&& lines[2].equals(tempCA.StateChoice.get(lines[0]).get(j).energy)
								  ){
									conInd = j;
									break;
								}
							}
							condition cnd;
							if(conInd==-1){
								cnd = new condition(lines[1],lines[2]);
							}
							else{
								cnd = tempCA.StateChoice.get(lines[0]).get(conInd);
							}
							cnd.actionRate.put(lines[3], Integer.valueOf(lines[4]));
							if(conInd == -1){
								tempCA.StateChoice.get(lines[0]).add(cnd);
							}
							else{
								tempCA.StateChoice.get(lines[0]).set(conInd, cnd);
							}
						}
					}
					else{
						for(int j=0;j<12;++j){
							if( tempCA.conditions.get(j).dist.equals(lines[1])
								&& tempCA.conditions.get(j).energy.equals(lines[2])){
								tempCA.conditions.get(j).actionRate.put(
										lines[3], Integer.valueOf(lines[4])
								);
							}
						}
					}
					line = br.readLine();
				}
				br.close();
				
				characters.add(tempCA);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		
		return 0;
	}

	@Override
	public String getCharacter() {
		// TODO Auto-generated method stub
		return CHARACTER_ZEN;
	}

	@Override
	public void getInformation(FrameData fd) {
		// TODO Auto-generated method stub
		this.frameData = fd;
		cc.setFrameData(this.frameData, playerNumber);
	}


	@Override
	public Key input() {
		// TODO Auto-generated method stub
		return inputKey;
	}

	int tableChosen = 0;
	boolean changed=false;
	@Override
	public void processing() {
		// TODO Auto-generated method stub
		if(!frameData.getEmptyFlag() && frameData.getRemainingTime() > 0){
			if(cc.getskillFlag())
			{
				inputKey = cc.getSkillKey();
			}
			else
			{	
				if( ( frameData.getRemainingTime()<32000 || frameData.getRemainingTime()<100)
					&& (cc.getEnemyHP()-cc.getMyHP()) > 100 && !changed){
					++tableChosen;
					tableChosen = tableChosen % dataNum;
					changed=true;
				}
				if( ( frameData.getRemainingTime() > 100 && frameData.getRemainingTime() < 150 ) 
					|| frameData.getRemainingTime() > 50000 && changed){
					changed=false;
				}
				Map<String,Integer> actionTable=null;
				inputKey.empty();
				cc.skillCancel();
				if( characters.get(tableChosen).StateChoice.containsKey(
						"State:"+cc.getEnemyCharacter().getState().name()
					) ){
					for( condition cond : characters.get(tableChosen).StateChoice.get(
							"State:"+cc.getEnemyCharacter().getState().name()
						 ) ){
						if( characters.get(tableChosen).getDistance().equals(cond.dist)
							&& ( cond.energy.equals("ALL")
								 || characters.get(tableChosen).getEnergyLevel().equals(cond.energy)
								)
							){
							actionTable = cond.actionRate;
							break;
						}
					}
				}
				
				if(actionTable == null){
					
					for(String key : characters.get(tableChosen).StartWith.keySet()){
						if(cc.getEnemyCharacter().getAction().name().startsWith(key)){
							for(condition cond : characters.get(tableChosen).StartWith.get(key)){
								if( ( cond.dist.equals("ALL") && cond.energy.equals("ALL") )
									|| ( characters.get(tableChosen).getDistance().equals(cond.dist)
										 && characters.get(tableChosen).getEnergyLevel().equals(cond.energy)
										)
									){
									actionTable = cond.actionRate;
									break;
								}
							}
							break;
						}
					}
					if(actionTable == null){
						actionTable = characters.get(tableChosen).conditions.get(
							characters.get(tableChosen).getIntDistance()*3 + characters.get(tableChosen).getIntEnergyLevel()
						).actionRate;
					}
				}
				int randInt = rnd.nextInt(100);

				
				for(Map.Entry<String, Integer> entry : actionTable.entrySet()){
					if(randInt < entry.getValue()){
						String command = entry.getKey().replace("@", " ");
						if(command.equals("forward")){
							if(cc.getMyCharacter().front){
								inputKey.R=true;
							}
							else{
								inputKey.L=true;
							}
						}
						else if(command.equals("guard")){
							if(cc.getMyCharacter().front){
								inputKey.D=true;
								inputKey.L=true;
							}
							else{
								inputKey.D=true;
								inputKey.R=true;
							}
						}
						else{
							cc.commandCall(command);
						}
						break;
					}
					else{
						randInt-=entry.getValue();
					}
				}
			}
		}
	}
	
	@Override
	public void close() {
		// TODO Auto-generated method stub

	}
}
