package StrategiesClass;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import enumerate.Action;
import structs.FrameData;

public class InitiativeStrategies {

	private File strFile;
	private FileWriter fileWriter;
	public PrintWriter printWriter;
	private BufferedReader bufReader;
	private boolean playerNumber;

	private String[][] NPASkill;

	public InitiativeStrategies() {

		strFile = new File("data/aiData/AI_ZBY0323/AIStr.txt");
		try {
			fileWriter = new FileWriter(strFile, true);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		NPASkill = null;
		printWriter = new PrintWriter(fileWriter);
		playerNumber = false;

	}

	public InitiativeStrategies(boolean thePlayerNumber, String[][] npaSkill) {

		playerNumber = thePlayerNumber;
		NPASkill = npaSkill;
		strFile = new File("data/aiData/AI_ZBY0323/AIStr.txt");
		try {
			fileWriter = new FileWriter(strFile, true);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		printWriter = new PrintWriter(fileWriter);

	}

	public String selectNextSkill(FrameData frameData) {
		Action oppNowAct = frameData.getOpponentCharacter(playerNumber).getAction();

		Pattern pattern = Pattern.compile("A" + "," + oppNowAct + ",.*");
		String strLine = "";

		String tempAction = null;
		int tempDamage = 0;

		try {
			bufReader = new BufferedReader(new FileReader(strFile));
			while ((strLine = bufReader.readLine()) != null) {
				Matcher matcher = pattern.matcher(strLine);
				if (matcher.find()) {
					strLine = matcher.group();
					String[] strLGroup = strLine.split(",");

					if (searchEnergyInNPAS(strLGroup[2]) <= frameData.getMyCharacter(playerNumber).getEnergy()) {
						int minX = Integer.parseInt(strLGroup[3]);
						int maxX = Integer.parseInt(strLGroup[4]);
						int minY = Integer.parseInt(strLGroup[5]);
						int maxY = Integer.parseInt(strLGroup[6]);

						int disX = getDistanceX(frameData);
						int disY = getDistanceY(frameData);

						if ((disX >= minX && disX <= maxX) && (disY >= minY && disY <= maxY)) {
							 int damage = searchDamageInNPAS(strLGroup[2]);
							if (damage > tempDamage) {
								tempDamage = damage;
								tempAction = strLGroup[2];
							}

						}
					}

				}
			}
			bufReader.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return tempAction;
	}

	public int searchEnergyInNPAS(String ActionName) {
		if (ActionName.equals("STAND_D_DF_FB")) {
			return 30;
		} else if (ActionName.equals("STAND_D_DF_FC")) {
			return 300;
		} else if (ActionName.equals("AIR_D_DF_FB")) {
			return 50;
		} else {
			int mySkillNum = -1;
			for (int i = 0; i < NPASkill.length; i++) {
				if (NPASkill[i][0].equals(ActionName)) {
					mySkillNum = i;
				}
			}
			
			if (mySkillNum != -1) {
				return Integer.parseInt(NPASkill[mySkillNum][6]);
			} else {
				return 0;
			}
		}
	}

	public int searchDamageInNPAS(String ActionName) {
		if (ActionName.equals("STAND_D_DF_FB")) {
			return 40;
		} else if (ActionName.equals("STAND_D_DF_FC")) {
			return 300;
		} else if (ActionName.equals("AIR_D_DF_FB")) {
			return 30;
		} else {

			int mySkillNum = -1;
			for (int i = 0; i < NPASkill.length; i++) {
				if (NPASkill[i][0].equals(ActionName)) {
					mySkillNum = i;
				}
			}

			if (mySkillNum != -1) {
				return Integer.parseInt(NPASkill[mySkillNum][1]);
			} else {
				return 0;
			}
		}
	}

	public String searchTheStr(FrameData frameData) {
		Pattern pattern = Pattern.compile("A" + "," + frameData.getOpponentCharacter(playerNumber).getAction() + ","
				+ frameData.getMyCharacter(playerNumber).getAction() + ",.*");
		String strLline = "";
		try {
			bufReader = new BufferedReader(new FileReader(strFile));
			while ((strLline = bufReader.readLine()) != null) {
				Matcher matcher = pattern.matcher(strLline);
				if (matcher.find()) {
					strLline = matcher.group();
					break;
				}
			}
			bufReader.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return strLline;
	}

	public String searchTheStr(Action oppAction, Action myAction) {
		Pattern pattern = Pattern.compile("A" + "," + oppAction + "," + myAction + ",.*");
		String strLline = "";
		try {
			bufReader = new BufferedReader(new FileReader(strFile));
			while ((strLline = bufReader.readLine()) != null) {
				Matcher matcher = pattern.matcher(strLline);
				if (matcher.find()) {
					strLline = matcher.group();
					break;
				}
			}
			bufReader.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return strLline;
	}

	public void updataTheStr(FrameData frameData, int newDamage, Action oppAction, Action myAction) {
		String strLine = searchTheStr(oppAction, myAction);
		if (strLine != null) {
			String[] strLGroup = strLine.split(",");

			int minDX = getDistanceX(frameData) < Integer.parseInt(strLGroup[3]) ? getDistanceX(frameData)
					: Integer.parseInt(strLGroup[3]);
			int maxDX = getDistanceX(frameData) > Integer.parseInt(strLGroup[4]) ? getDistanceX(frameData)
					: Integer.parseInt(strLGroup[4]);
			int minDY = getDistanceY(frameData) < Integer.parseInt(strLGroup[5]) ? getDistanceY(frameData)
					: Integer.parseInt(strLGroup[5]);
			int maxDY = getDistanceY(frameData) > Integer.parseInt(strLGroup[6]) ? getDistanceY(frameData)
					: Integer.parseInt(strLGroup[6]);

			int damage = Integer.parseInt(strLGroup[7]) == newDamage ? Integer.parseInt(strLGroup[7]) : newDamage;

			replaceString(strLine,
					strLGroup[0] + "," + strLGroup[1] + "," + strLGroup[2] + "," + minDX + "," + maxDX + "," + minDY
							+ "," + maxDY + "," + damage + "," + strLGroup[8] + "," + strLGroup[9] + ","
							+ strLGroup[10]);
		}
	}

	public void replaceString(String oldStr, String replaceStr) {
		String temp = "";
		try {
			FileInputStream fis = new FileInputStream(strFile);
			InputStreamReader isr = new InputStreamReader(fis);
			BufferedReader br = new BufferedReader(isr);
			StringBuffer buf = new StringBuffer();

			//save front
			for (int j = 1; (temp = br.readLine()) != null && !temp.equals(oldStr); j++) {
				buf = buf.append(temp);
				buf = buf.append(System.getProperty("line.separator"));
			}

			//insert
			buf = buf.append(replaceStr);

			//save remaining
			while ((temp = br.readLine()) != null) {
				buf = buf.append(System.getProperty("line.separator"));
				buf = buf.append(temp);
			}

			br.close();
			FileOutputStream fos = new FileOutputStream(strFile);
			PrintWriter pw = new PrintWriter(fos);
			pw.write(buf.toString().toCharArray());
			pw.flush();
			pw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public int getDistanceX(FrameData frameData) {
		if (frameData.getMyCharacter(playerNumber).isFront())
			return Math.abs(frameData.getMyCharacter(playerNumber).getX()
					- frameData.getOpponentCharacter(playerNumber).getX() - 120);
		else
			return Math.abs(frameData.getMyCharacter(playerNumber).getX()
					- frameData.getOpponentCharacter(playerNumber).getX() + 120);
	}

	public int getDistanceY(FrameData frameData) {
		return frameData.getMyCharacter(playerNumber).getY() - frameData.getOpponentCharacter(playerNumber).getY();
	}

}
